#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
//import help from 'help.md';
const help = 'See /usr/share/doc/rollup/help.md or man rollup';
const minimist_1 = __importDefault(require("minimist"));
const version = '1.12.0';
const mergeOptions_1 = require("../../src/utils/mergeOptions");
const index_1 = __importDefault(require("./run/index"));
const command = minimist_1.default(process.argv.slice(2), {
    alias: mergeOptions_1.commandAliases
});
if (command.help || (process.argv.length <= 2 && process.stdin.isTTY)) {
    console.log(`\n${help.replace('__VERSION__', version)}\n`);
}
else if (command.version) {
    console.log(`rollup v${version}`);
}
else {
    try {
        require('source-map-support').install();
    }
    catch (err) {
        // do nothing
    }
    index_1.default(command);
}
