"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const pretty_bytes_1 = __importDefault(require("pretty-bytes"));
const turbocolor_1 = __importDefault(require("turbocolor"));
function printTimings(timings) {
    Object.keys(timings).forEach(label => {
        const color = label[0] === '#' ? (label[1] !== '#' ? turbocolor_1.default.underline : turbocolor_1.default.bold) : (text) => text;
        const [time, memory, total] = timings[label];
        const row = `${label}: ${time.toFixed(0)}ms, ${pretty_bytes_1.default(memory)} / ${pretty_bytes_1.default(total)}`;
        console.info(color(row));
    });
}
exports.printTimings = printTimings;
