"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const values_1 = require("../values");
const Node_1 = require("./shared/Node");
class ArrayExpression extends Node_1.NodeBase {
    bind() {
        super.bind();
        for (const element of this.elements) {
            if (element !== null)
                element.deoptimizePath(values_1.UNKNOWN_PATH);
        }
    }
    getReturnExpressionWhenCalledAtPath(path) {
        if (path.length !== 1)
            return values_1.UNKNOWN_EXPRESSION;
        return values_1.getMemberReturnExpressionWhenCalled(values_1.arrayMembers, path[0]);
    }
    hasEffectsWhenAccessedAtPath(path) {
        return path.length > 1;
    }
    hasEffectsWhenCalledAtPath(path, callOptions, options) {
        if (path.length === 1) {
            return values_1.hasMemberEffectWhenCalled(values_1.arrayMembers, path[0], this.included, callOptions, options);
        }
        return true;
    }
}
exports.default = ArrayExpression;
