"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const blank_1 = require("../../utils/blank");
const values_1 = require("../values");
const Node_1 = require("./shared/Node");
class AssignmentPattern extends Node_1.NodeBase {
    addExportedVariables(variables) {
        this.left.addExportedVariables(variables);
    }
    bind() {
        super.bind();
        this.left.deoptimizePath(values_1.EMPTY_PATH);
        this.right.deoptimizePath(values_1.UNKNOWN_PATH);
    }
    declare(kind, init) {
        this.left.declare(kind, init);
    }
    deoptimizePath(path) {
        path.length === 0 && this.left.deoptimizePath(path);
    }
    hasEffectsWhenAssignedAtPath(path, options) {
        return path.length > 0 || this.left.hasEffectsWhenAssignedAtPath(values_1.EMPTY_PATH, options);
    }
    render(code, options, { isShorthandProperty } = blank_1.BLANK) {
        this.left.render(code, options, { isShorthandProperty });
        this.right.render(code, options);
    }
}
exports.default = AssignmentPattern;
