"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ArrowFunctionExpression_1 = __importDefault(require("./ArrowFunctionExpression"));
const FunctionNode_1 = __importDefault(require("./shared/FunctionNode"));
const Node_1 = require("./shared/Node");
class AwaitExpression extends Node_1.NodeBase {
    hasEffects(options) {
        return super.hasEffects(options) || !options.ignoreReturnAwaitYield();
    }
    include(includeAllChildrenRecursively) {
        super.include(includeAllChildrenRecursively);
        if (!this.context.usesTopLevelAwait) {
            let parent = this.parent;
            do {
                if (parent instanceof FunctionNode_1.default || parent instanceof ArrowFunctionExpression_1.default)
                    return;
            } while ((parent = parent.parent));
            this.context.usesTopLevelAwait = true;
        }
    }
    render(code, options) {
        super.render(code, options);
    }
}
exports.default = AwaitExpression;
