"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const CatchScope_1 = __importDefault(require("../scopes/CatchScope"));
const values_1 = require("../values");
const Node_1 = require("./shared/Node");
class CatchClause extends Node_1.NodeBase {
    createScope(parentScope) {
        this.scope = new CatchScope_1.default(parentScope, this.context);
    }
    initialise() {
        this.included = false;
        if (this.param) {
            this.param.declare('parameter', values_1.UNKNOWN_EXPRESSION);
        }
    }
    parseNode(esTreeNode) {
        this.body = (new this.context.nodeConstructors.BlockStatement(esTreeNode.body, this, this.scope));
        super.parseNode(esTreeNode);
    }
}
exports.default = CatchClause;
CatchClause.prototype.preventChildBlockScope = true;
