"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const blank_1 = require("../../utils/blank");
const Node_1 = require("./shared/Node");
class ExportNamedDeclaration extends Node_1.NodeBase {
    bind() {
        // Do not bind specifiers
        if (this.declaration !== null)
            this.declaration.bind();
    }
    hasEffects(options) {
        return this.declaration && this.declaration.hasEffects(options);
    }
    initialise() {
        this.included = false;
        this.context.addExport(this);
    }
    render(code, options, { start, end } = blank_1.BLANK) {
        if (this.declaration === null) {
            code.remove(start, end);
        }
        else {
            code.remove(this.start, this.declaration.start);
            this.declaration.render(code, options, { start, end });
        }
    }
}
exports.default = ExportNamedDeclaration;
ExportNamedDeclaration.prototype.needsBoundaries = true;
