"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const NodeType = __importStar(require("./NodeType"));
const Node_1 = require("./shared/Node");
class ExpressionStatement extends Node_1.StatementBase {
    initialise() {
        this.included = false;
        if (this.directive &&
            this.directive !== 'use strict' &&
            this.parent.type === NodeType.Program) {
            this.context.warn(
            // This is necessary, because either way (deleting or not) can lead to errors.
            {
                code: 'MODULE_LEVEL_DIRECTIVE',
                message: `Module level directives cause errors when bundled, '${this.directive}' was ignored.`
            }, this.start);
        }
    }
    render(code, options) {
        super.render(code, options);
        if (this.included)
            this.insertSemicolon(code);
    }
    shouldBeIncluded() {
        if (this.directive && this.directive !== 'use strict')
            return this.parent.type !== NodeType.Program;
        return super.shouldBeIncluded();
    }
}
exports.default = ExpressionStatement;
