"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const renderHelpers_1 = require("../../utils/renderHelpers");
const Node_1 = require("./shared/Node");
class Program extends Node_1.NodeBase {
    hasEffects(options) {
        for (const node of this.body) {
            if (node.hasEffects(options))
                return true;
        }
    }
    include(includeAllChildrenRecursively) {
        this.included = true;
        for (const node of this.body) {
            if (includeAllChildrenRecursively || node.shouldBeIncluded()) {
                node.include(includeAllChildrenRecursively);
            }
        }
    }
    render(code, options) {
        if (this.body.length) {
            renderHelpers_1.renderStatementList(this.body, code, this.start, this.end, options);
        }
        else {
            super.render(code, options);
        }
    }
}
exports.default = Program;
