"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const values_1 = require("../values");
const Node_1 = require("./shared/Node");
class RestElement extends Node_1.NodeBase {
    constructor() {
        super(...arguments);
        this.declarationInit = null;
    }
    addExportedVariables(variables) {
        this.argument.addExportedVariables(variables);
    }
    bind() {
        super.bind();
        if (this.declarationInit !== null) {
            this.declarationInit.deoptimizePath([values_1.UNKNOWN_KEY, values_1.UNKNOWN_KEY]);
        }
    }
    declare(kind, init) {
        this.argument.declare(kind, values_1.UNKNOWN_EXPRESSION);
        this.declarationInit = init;
    }
    deoptimizePath(path) {
        path.length === 0 && this.argument.deoptimizePath(values_1.EMPTY_PATH);
    }
    hasEffectsWhenAssignedAtPath(path, options) {
        return path.length > 0 || this.argument.hasEffectsWhenAssignedAtPath(values_1.EMPTY_PATH, options);
    }
}
exports.default = RestElement;
