"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const renderHelpers_1 = require("../../utils/renderHelpers");
const Node_1 = require("./shared/Node");
class SwitchCase extends Node_1.NodeBase {
    include(includeAllChildrenRecursively) {
        this.included = true;
        if (this.test)
            this.test.include(includeAllChildrenRecursively);
        for (const node of this.consequent) {
            if (includeAllChildrenRecursively || node.shouldBeIncluded())
                node.include(includeAllChildrenRecursively);
        }
    }
    render(code, options) {
        if (this.consequent.length) {
            this.test && this.test.render(code, options);
            const testEnd = this.test
                ? this.test.end
                : renderHelpers_1.findFirstOccurrenceOutsideComment(code.original, 'default', this.start) + 7;
            const consequentStart = renderHelpers_1.findFirstOccurrenceOutsideComment(code.original, ':', testEnd) + 1;
            renderHelpers_1.renderStatementList(this.consequent, code, consequentStart, this.end, options);
        }
        else {
            super.render(code, options);
        }
    }
}
exports.default = SwitchCase;
