"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const values_1 = require("../values");
const NodeType = __importStar(require("./NodeType"));
const Node_1 = require("./shared/Node");
function isTemplateLiteral(node) {
    return node.type === NodeType.TemplateLiteral;
}
exports.isTemplateLiteral = isTemplateLiteral;
class TemplateLiteral extends Node_1.NodeBase {
    getLiteralValueAtPath(path) {
        if (path.length > 0 || this.quasis.length !== 1) {
            return values_1.UNKNOWN_VALUE;
        }
        return this.quasis[0].value.cooked;
    }
    render(code, options) {
        code.indentExclusionRanges.push([this.start, this.end]);
        super.render(code, options);
    }
}
exports.default = TemplateLiteral;
