"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ArrayExpression_1 = __importDefault(require("./ArrayExpression"));
const ArrayPattern_1 = __importDefault(require("./ArrayPattern"));
const ArrowFunctionExpression_1 = __importDefault(require("./ArrowFunctionExpression"));
const AssignmentExpression_1 = __importDefault(require("./AssignmentExpression"));
const AssignmentPattern_1 = __importDefault(require("./AssignmentPattern"));
const AwaitExpression_1 = __importDefault(require("./AwaitExpression"));
const BinaryExpression_1 = __importDefault(require("./BinaryExpression"));
const BlockStatement_1 = __importDefault(require("./BlockStatement"));
const BreakStatement_1 = __importDefault(require("./BreakStatement"));
const CallExpression_1 = __importDefault(require("./CallExpression"));
const CatchClause_1 = __importDefault(require("./CatchClause"));
const ClassBody_1 = __importDefault(require("./ClassBody"));
const ClassDeclaration_1 = __importDefault(require("./ClassDeclaration"));
const ClassExpression_1 = __importDefault(require("./ClassExpression"));
const ConditionalExpression_1 = __importDefault(require("./ConditionalExpression"));
const DoWhileStatement_1 = __importDefault(require("./DoWhileStatement"));
const EmptyStatement_1 = __importDefault(require("./EmptyStatement"));
const ExportAllDeclaration_1 = __importDefault(require("./ExportAllDeclaration"));
const ExportDefaultDeclaration_1 = __importDefault(require("./ExportDefaultDeclaration"));
const ExportNamedDeclaration_1 = __importDefault(require("./ExportNamedDeclaration"));
const ExpressionStatement_1 = __importDefault(require("./ExpressionStatement"));
const ForInStatement_1 = __importDefault(require("./ForInStatement"));
const ForOfStatement_1 = __importDefault(require("./ForOfStatement"));
const ForStatement_1 = __importDefault(require("./ForStatement"));
const FunctionDeclaration_1 = __importDefault(require("./FunctionDeclaration"));
const FunctionExpression_1 = __importDefault(require("./FunctionExpression"));
const Identifier_1 = __importDefault(require("./Identifier"));
const IfStatement_1 = __importDefault(require("./IfStatement"));
const Import_1 = __importDefault(require("./Import"));
const ImportDeclaration_1 = __importDefault(require("./ImportDeclaration"));
const LabeledStatement_1 = __importDefault(require("./LabeledStatement"));
const Literal_1 = __importDefault(require("./Literal"));
const LogicalExpression_1 = __importDefault(require("./LogicalExpression"));
const MemberExpression_1 = __importDefault(require("./MemberExpression"));
const MetaProperty_1 = __importDefault(require("./MetaProperty"));
const MethodDefinition_1 = __importDefault(require("./MethodDefinition"));
const NewExpression_1 = __importDefault(require("./NewExpression"));
const ObjectExpression_1 = __importDefault(require("./ObjectExpression"));
const ObjectPattern_1 = __importDefault(require("./ObjectPattern"));
const Program_1 = __importDefault(require("./Program"));
const Property_1 = __importDefault(require("./Property"));
const RestElement_1 = __importDefault(require("./RestElement"));
const ReturnStatement_1 = __importDefault(require("./ReturnStatement"));
const SequenceExpression_1 = __importDefault(require("./SequenceExpression"));
const Node_1 = require("./shared/Node");
const SpreadElement_1 = __importDefault(require("./SpreadElement"));
const SwitchCase_1 = __importDefault(require("./SwitchCase"));
const SwitchStatement_1 = __importDefault(require("./SwitchStatement"));
const TaggedTemplateExpression_1 = __importDefault(require("./TaggedTemplateExpression"));
const TemplateElement_1 = __importDefault(require("./TemplateElement"));
const TemplateLiteral_1 = __importDefault(require("./TemplateLiteral"));
const ThisExpression_1 = __importDefault(require("./ThisExpression"));
const ThrowStatement_1 = __importDefault(require("./ThrowStatement"));
const UnaryExpression_1 = __importDefault(require("./UnaryExpression"));
const UnknownNode_1 = __importDefault(require("./UnknownNode"));
const UpdateExpression_1 = __importDefault(require("./UpdateExpression"));
const VariableDeclaration_1 = __importDefault(require("./VariableDeclaration"));
const VariableDeclarator_1 = __importDefault(require("./VariableDeclarator"));
const WhileStatement_1 = __importDefault(require("./WhileStatement"));
const YieldExpression_1 = __importDefault(require("./YieldExpression"));
exports.nodeConstructors = {
    ArrayExpression: ArrayExpression_1.default,
    ArrayPattern: ArrayPattern_1.default,
    ArrowFunctionExpression: ArrowFunctionExpression_1.default,
    AssignmentExpression: AssignmentExpression_1.default,
    AssignmentPattern: AssignmentPattern_1.default,
    AwaitExpression: AwaitExpression_1.default,
    BinaryExpression: BinaryExpression_1.default,
    BlockStatement: BlockStatement_1.default,
    BreakStatement: BreakStatement_1.default,
    CallExpression: CallExpression_1.default,
    CatchClause: CatchClause_1.default,
    ClassBody: ClassBody_1.default,
    ClassDeclaration: ClassDeclaration_1.default,
    ClassExpression: ClassExpression_1.default,
    ConditionalExpression: ConditionalExpression_1.default,
    DoWhileStatement: DoWhileStatement_1.default,
    EmptyStatement: EmptyStatement_1.default,
    ExportAllDeclaration: ExportAllDeclaration_1.default,
    ExportDefaultDeclaration: ExportDefaultDeclaration_1.default,
    ExportNamedDeclaration: ExportNamedDeclaration_1.default,
    ExpressionStatement: ExpressionStatement_1.default,
    ForInStatement: ForInStatement_1.default,
    ForOfStatement: ForOfStatement_1.default,
    ForStatement: ForStatement_1.default,
    FunctionDeclaration: FunctionDeclaration_1.default,
    FunctionExpression: FunctionExpression_1.default,
    Identifier: Identifier_1.default,
    IfStatement: IfStatement_1.default,
    Import: Import_1.default,
    ImportDeclaration: ImportDeclaration_1.default,
    LabeledStatement: LabeledStatement_1.default,
    Literal: Literal_1.default,
    LogicalExpression: LogicalExpression_1.default,
    MemberExpression: MemberExpression_1.default,
    MetaProperty: MetaProperty_1.default,
    MethodDefinition: MethodDefinition_1.default,
    NewExpression: NewExpression_1.default,
    ObjectExpression: ObjectExpression_1.default,
    ObjectPattern: ObjectPattern_1.default,
    Program: Program_1.default,
    Property: Property_1.default,
    RestElement: RestElement_1.default,
    ReturnStatement: ReturnStatement_1.default,
    SequenceExpression: SequenceExpression_1.default,
    SpreadElement: SpreadElement_1.default,
    SwitchCase: SwitchCase_1.default,
    SwitchStatement: SwitchStatement_1.default,
    TaggedTemplateExpression: TaggedTemplateExpression_1.default,
    TemplateElement: TemplateElement_1.default,
    TemplateLiteral: TemplateLiteral_1.default,
    ThisExpression: ThisExpression_1.default,
    ThrowStatement: ThrowStatement_1.default,
    TryStatement: Node_1.StatementBase,
    UnaryExpression: UnaryExpression_1.default,
    UnknownNode: UnknownNode_1.default,
    UpdateExpression: UpdateExpression_1.default,
    VariableDeclaration: VariableDeclaration_1.default,
    VariableDeclarator: VariableDeclarator_1.default,
    WhileStatement: WhileStatement_1.default,
    YieldExpression: YieldExpression_1.default
};
