"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ChildScope_1 = __importDefault(require("../../scopes/ChildScope"));
const Node_1 = require("./Node");
class ClassNode extends Node_1.NodeBase {
    createScope(parentScope) {
        this.scope = new ChildScope_1.default(parentScope);
    }
    hasEffectsWhenAccessedAtPath(path, _options) {
        return path.length > 1;
    }
    hasEffectsWhenAssignedAtPath(path, _options) {
        return path.length > 1;
    }
    hasEffectsWhenCalledAtPath(path, callOptions, options) {
        return (this.body.hasEffectsWhenCalledAtPath(path, callOptions, options) ||
            (this.superClass && this.superClass.hasEffectsWhenCalledAtPath(path, callOptions, options)));
    }
    initialise() {
        this.included = false;
        if (this.id !== null) {
            this.id.declare('class', this);
        }
    }
}
exports.default = ClassNode;
