"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const values_1 = require("../values");
const ArgumentsVariable_1 = __importDefault(require("../variables/ArgumentsVariable"));
const ThisVariable_1 = __importDefault(require("../variables/ThisVariable"));
const ReturnValueScope_1 = __importDefault(require("./ReturnValueScope"));
class FunctionScope extends ReturnValueScope_1.default {
    constructor(parent, context) {
        super(parent, context);
        this.variables.arguments = new ArgumentsVariable_1.default(super.getParameterVariables(), context);
        this.variables.this = new ThisVariable_1.default(context);
    }
    findLexicalBoundary() {
        return this;
    }
    getOptionsWhenCalledWith({ args, withNew }, options) {
        return options
            .replaceVariableInit(this.variables.this, withNew ? new values_1.UnknownObjectExpression() : values_1.UNKNOWN_EXPRESSION)
            .setArgumentsVariables(args.map((parameter, index) => super.getParameterVariables()[index] || parameter));
    }
}
exports.default = FunctionScope;
