"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const values_1 = require("../values");
const LocalVariable_1 = __importDefault(require("../variables/LocalVariable"));
const ChildScope_1 = __importDefault(require("./ChildScope"));
class ParameterScope extends ChildScope_1.default {
    constructor(parent, context) {
        super(parent);
        this.parameters = [];
        this.context = context;
        this.hoistedBodyVarScope = new ChildScope_1.default(this);
    }
    /**
     * Adds a parameter to this scope. Parameters must be added in the correct
     * order, e.g. from left to right.
     */
    addParameterDeclaration(identifier) {
        const name = identifier.name;
        let variable;
        if (name in this.hoistedBodyVarScope.variables) {
            variable = this.hoistedBodyVarScope.variables[name];
            variable.addDeclaration(identifier, null);
        }
        else {
            variable = new LocalVariable_1.default(name, identifier, values_1.UNKNOWN_EXPRESSION, this.context);
        }
        this.variables[name] = variable;
        this.parameters.push(variable);
        return variable;
    }
    getParameterVariables() {
        return this.parameters;
    }
}
exports.default = ParameterScope;
