"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const values_1 = require("../values");
const LocalVariable_1 = __importDefault(require("../variables/LocalVariable"));
class Scope {
    constructor() {
        this.children = [];
        this.variables = Object.create(null);
    }
    addDeclaration(identifier, context, init = null, _isHoisted) {
        const name = identifier.name;
        if (this.variables[name]) {
            this.variables[name].addDeclaration(identifier, init);
        }
        else {
            this.variables[name] = new LocalVariable_1.default(identifier.name, identifier, init || values_1.UNDEFINED_EXPRESSION, context);
        }
        return this.variables[name];
    }
    contains(name) {
        return name in this.variables;
    }
    findVariable(_name) {
        throw new Error('Internal Error: findVariable needs to be implemented by a subclass');
    }
}
exports.default = Scope;
