"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const immutable_1 = __importDefault(require("immutable"));
const RESULT_KEY = {};
class ImmutableEntityPathTracker {
    constructor(existingEntityPaths = immutable_1.default.Map()) {
        this.entityPaths = existingEntityPaths;
    }
    isTracked(entity, path) {
        return this.entityPaths.getIn([entity, ...path, RESULT_KEY]);
    }
    track(entity, path) {
        return new ImmutableEntityPathTracker(this.entityPaths.setIn([entity, ...path, RESULT_KEY], true));
    }
}
exports.ImmutableEntityPathTracker = ImmutableEntityPathTracker;
exports.EMPTY_IMMUTABLE_TRACKER = new ImmutableEntityPathTracker();
