"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const pureFunctions_1 = __importDefault(require("../nodes/shared/pureFunctions"));
const Variable_1 = __importDefault(require("./Variable"));
class GlobalVariable extends Variable_1.default {
    hasEffectsWhenAccessedAtPath(path) {
        // path.length == 0 can also have an effect but we postpone this for now
        return (path.length > 0 &&
            !this.isPureFunctionMember(path) &&
            !(this.name === 'Reflect' && path.length === 1));
    }
    hasEffectsWhenCalledAtPath(path) {
        return !pureFunctions_1.default[[this.name, ...path].join('.')];
    }
    isPureFunctionMember(path) {
        return (pureFunctions_1.default[[this.name, ...path].join('.')] ||
            (path.length >= 1 && pureFunctions_1.default[[this.name, ...path.slice(0, -1)].join('.')]) ||
            (path.length >= 2 &&
                pureFunctions_1.default[[this.name, ...path.slice(0, -2)].join('.')] &&
                path[path.length - 2] === 'prototype'));
    }
}
exports.default = GlobalVariable;
