"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("./path");
function getAliasName(id) {
    const base = path_1.basename(id);
    return base.substr(0, base.length - path_1.extname(id).length);
}
exports.getAliasName = getAliasName;
function relativeId(id) {
    if (typeof process === 'undefined' || !path_1.isAbsolute(id))
        return id;
    return path_1.relative(process.cwd(), id);
}
exports.default = relativeId;
function isPlainName(name) {
    // not starting with "./", "/". "../"
    return !(name[0] === '/' ||
        (name[1] === '.' && (name[2] === '/' || (name[2] === '.' && name[3] === '/'))));
}
exports.isPlainName = isPlainName;
