"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ExternalModule_1 = __importDefault(require("../ExternalModule"));
function markModuleAndImpureDependenciesAsExecuted(baseModule) {
    baseModule.isExecuted = true;
    const modules = [baseModule];
    const visitedModules = {};
    for (const module of modules) {
        for (const dependency of module.dependencies) {
            if (!(dependency instanceof ExternalModule_1.default) &&
                !dependency.isExecuted &&
                dependency.moduleSideEffects &&
                !visitedModules[dependency.id]) {
                dependency.isExecuted = true;
                visitedModules[dependency.id] = true;
                modules.push(dependency);
            }
        }
    }
}
exports.markModuleAndImpureDependenciesAsExecuted = markModuleAndImpureDependenciesAsExecuted;
